#!/bin/bash

. ./.jprojects.sh || exit 255

SOURCE_BRANCH="master"
TARGET_BRANCH="rewrites/jpa"
SWITCH_TO_SOURCE="Y"

for project in ${LIST}; do
	if [ "${project}" = "jprojects-scripts" ]
	then
		echo "$0: Skipping jprojects-scripts ..."
		continue
	elif [ ! -d "${JPROJECTS_HOME}/${project}" ]
	then
		echo "$0: Project '${project}' does not exist."
		continue
	fi

	echo "$0: Processing '${project}' ..."
	cd "${JPROJECTS_HOME}/${project}"

	# Make sure the source branch is there
	git checkout "${SOURCE_BRANCH}" || exit 255

	# ... and target branch
	git checkout "${TARGET_BRANCH}" 2>&1
	STATUS="$?"

	if [ "${STATUS}" = "0" ]
	then
		# Then merge
		echo "$0: Merging '${SOURCE_BRANCH}' in project '${project}' ..."
		git merge -S "${SOURCE_BRANCH}" || exit 255

		if [ "${SWITCH_TO_SOURCE}" = "Y" ]
		then
			echo "$0: Switching back to '${SOURCE_BRANCH}'"
			git checkout "${SOURCE_BRANCH}"
		fi
	else
		echo "$0: Project '${project}' has no branch '${TARGET_BRANCH}'."
	fi
done

echo "$0: All done."
exit 0
